package api

import (
	"context"
	"fmt"
	"net/http"

	"github.com/rs/zerolog/log"
	"source.gleipnir.technology/Gleipnir/nidus-sync/comms/email"
	"source.gleipnir.technology/Gleipnir/nidus-sync/comms/text"
	"source.gleipnir.technology/Gleipnir/nidus-sync/config"
	nhttp "source.gleipnir.technology/Gleipnir/nidus-sync/http"
	"source.gleipnir.technology/Gleipnir/nidus-sync/platform"
)

type FormEmail struct {
	Body    string `schema:"emailBody"`
	From    string `schema:"emailFrom"`
	Subject string `schema:"emailSubject"`
	To      string `schema:"emailTo"`
}

func postSudoEmail(ctx context.Context, r *http.Request, u platform.User, e FormEmail) (string, *nhttp.ErrorWithStatus) {
	if !u.HasRoot() {
		return "", &nhttp.ErrorWithStatus{
			Message: "You must have sudo powers to do this",
			Status:  http.StatusForbidden,
		}
	}
	request := email.Request{
		From:    e.From,
		HTML:    fmt.Sprintf("<html><p>%s</p></html>", e.Body),
		Sender:  e.From,
		Subject: e.Subject,
		To:      e.To,
		Text:    e.Body,
	}
	resp, err := email.Send(ctx, request)
	if err != nil {
		log.Warn().Err(err).Msg("Failed to send email")
	} else {
		log.Info().Str("id", resp.ID).Str("to", e.To).Msg("Sent Email")
	}
	return "/sudo", nil
}

type FormSMS struct {
	Message string `schema:"smsMessage"`
	Phone   string `schema:"smsPhone"`
}

func postSudoSMS(ctx context.Context, r *http.Request, u platform.User, sms FormSMS) (string, *nhttp.ErrorWithStatus) {
	if !u.HasRoot() {
		return "", &nhttp.ErrorWithStatus{
			Message: "You must have sudo powers to do this",
			Status:  http.StatusForbidden,
		}
	}
	id, err := text.SendText(ctx, config.VoipMSNumber, sms.Phone, sms.Message)
	if err != nil {
		log.Warn().Err(err).Msg("Failed to send SMS")
	} else {
		log.Info().Str("id", id).Msg("Sent SMS")
	}
	return "/sudo", nil
}

type FormSSE struct {
	OrganizationID int32  `schema:"organizationID"`
	Resource       string `schema:"resource"`
	Type           string `schema:"type"`
	URIPath        string `schema:"uriPath"`
}

func postSudoSSE(ctx context.Context, r *http.Request, u platform.User, sse FormSSE) (string, *nhttp.ErrorWithStatus) {
	if !u.HasRoot() {
		return "", &nhttp.ErrorWithStatus{
			Message: "You must have sudo powers to do this",
			Status:  http.StatusForbidden,
		}
	}
	platform.SudoEvent(sse.OrganizationID, sse.Resource, sse.Type, sse.URIPath)
	return "/sudo", nil
}
